#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# ZetpeR xax007@yandex.ru
# PS2 Hana To Otome ni Shukufuku o Harukaze no Okurimono распаковка сжатия .1tex и конвектор картинок
# Время распаковки всех файлов занимает примерно 8 минут

import os, sys
import struct
import time
import datetime
import io
from PIL import Image

path = os.path.realpath(os.path.dirname(sys.argv[0]))

class Profiler(object):
    def __enter__(self):
        self._startTime = time.time()
    def __exit__(self, type, value, traceback):
        dd = time.time() - self._startTime
        seconds_f, mikro = str(dd).split(".")
        print("Часы минуты секунды",str(datetime.timedelta(seconds=int(seconds_f))),"", "{:.3f} sec".format(time.time() - self._startTime))

def main():
    if os.path.exists(path+"\\Unpack") == False:
        os.makedirs(path+"\\Unpack")
    with Profiler() as p:
        for mult_file in os.listdir(path):
            if mult_file.lower().endswith(('.1tex')):
                Unpack(mult_file)
    print("Закрыть")

def Unpack(mult_file):
    f = open(path+"\\"+mult_file,"rb")
    fd = f.read()
    f.close()
    f = io.BytesIO(fd) # Загружаем файл в память Для быстрой работы

    type = f.read(4)
    if type != b'1tex': # Проверка
        print("ЭТО НЕ сжатый файл",type,mult_file)
        return(0) # Остановка скрипта

    f2 = io.BytesIO()

    unclear = f.read(4) # Непонятно
    HEX = unclear.hex(' ').upper()
    print(mult_file,"4 байта непонятно",HEX)

    while True:
        check = f.read(1)[0] # Управляющий байт

        if check == 0x00: # Конец файла
            #print("Конец файла\n")
            break

        elif check >= 0x80: # Сколько прочетать байт
            col = (0xFF-(check))+3 # Сколько прочетать байт

            back = struct.unpack("B",f.read(1))[0] +1 # Насколько байт отойти назад
            posf = f2.tell() - back # Позиция чтения
            for j3 in range(col): # Сколько прочетать байт
                f2.seek(posf) # Преход на нужное место
                fd = f2.read(1) # Читаем байт
                f2.seek(0,2) # Перейти в конец файла
                f2.write(fd) # Запись байта
                posf += 1

            #print("Сколько прочетать байт из распакованого файла",col)

        else: # check <= 0x7F:
            #print("Записать байтов",check)
            fd = f.read(check) # Просто читаем байты
            f2.write(fd)

    f.close()

    #f3 = open(path+"\\Unpack\\"+mult_file[:-5]+".bin", "wb")
    #f2.seek(0)
    #fd = f2.read()
    #f3.write(fd)
    #f3.close()

    Unpack_2(f2, mult_file[:-5]) # Конвертация картинок

    f2.close()

def Unpack_2(f, mult_file):
    ss = 0 # Счётчик файлов

    f.seek(0,2)
    end_f = f.tell() # Конец файла
    f.seek(0)

    while True:
        ss += 1
        if f.tell() == end_f-16: # Конец файла
            #print("Конец файла")
            break

        type = f.read(2) # Заголовок T2
        w, h = struct.unpack("<HH",f.read(4)) # Ширина и высота
        unclear = f.read(26) # Непонятно
        fd = f.read(w*h)

        # Чтение палитры и конвертация палитры Tim2 в правельную
        unclear_2 = f.read(32) # Заголовок с данными

        f_Pal = io.BytesIO()
        for i in range(8):
            block1 = f.read(32)
            block2 = f.read(32)
            block3 = f.read(32)
            block4 = f.read(32)
            f_Pal.write(block1)
            f_Pal.write(block3)
            f_Pal.write(block2)
            f_Pal.write(block4)
        f_Pal.seek(0)

        Pal = b''
        for i in range(256):
            Pal += f_Pal.read(3)
            Pal += bytes([scale_alpha(f_Pal.read(1)[0])])
        f_Pal.close()

        Pal = list(Pal)
        im = Image.new("RGBA", (w,h))
        pixels = im.load()
        x = 0
        y = 0
        for i in range(w * h):
            c = fd[i]
            pixels[x, y] = tuple(Pal[c*4:c*4+4])
            x += 1
            if x == w:
                x = 0
                y += 1

        im.save(path+"\\Unpack\\"+mult_file+" "+str(ss)+".png", "PNG")
        im.close()
    f.close()

def scale_alpha(a):
    return int(min(255.0 * (a / 128.0), 0xFF))

if __name__ == "__main__":
    main()
    input()